



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>angular 缓存模板  ng-template $templateCache</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">angular 缓存模板  ng-template $templateCache</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 22:36:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>由于浏览器加载html模板是异步加载的，如果加载大量的模板会拖慢网站的速度，这里有一个技巧，就是先缓存模板。&nbsp;<br />使用angular缓存模板主要有三种方法：&nbsp;<br /><strong>方法一：通过script标签引入</strong></p>
<div>
<pre class="prettyprint linenums">&lt;script type="text/ng-template" id="hello.html"&gt;<br />
    &lt;h4&gt;hello&lt;/h4&gt;<br />
    &lt;p&gt;这是script标签获取模板文件的方式&lt;/p&gt;<br />
    &lt;a href="http://www.baidu.com"&gt;标签启用templateCache方式&lt;/a&gt;<br />
&lt;/script&gt;</pre>
</div>
<p>注意，这里的id只是指十几使用模板时的一个引用，而不是一个url， 模板的实际内容在script标签里。ng-template指明这是angular模板。&nbsp;<br />当然，模板的实际内容我们也可以使用themeleaf的标签来引用一些html页面，如th:include和th:replace。</p>
<div>
<pre class="prettyprint linenums">&lt;script type="text/ng-template" id="hello.html"&gt;<br />
    &lt;div th:replace="components/header :: header"&gt;&lt;/div&gt;

    //&lt;div th:include="components/footer :: footer"&gt;&lt;/div&gt;<br />
&lt;/script&gt;</pre>
</div>
<p>th:replace和th:include的参数格式是：templatename::[domselector]表示引入模板页面中的某个模块。&nbsp;<br />其中templatename引入模板页面，domselector引入自身模板的模块。&nbsp;<br />注意：script标签模板不需要包含在文档头部。但他必须在$rootElement下，不然模板将会被忽略。</p>
<p><strong>方法二：通过$templateCache服务来实现</strong></p>
<div>
<pre class="prettyprint linenums">angular.module('myApp', [])<br />
  .controller('myCtrl', ['$scope','$templateCache', function($scope,$templateCache){<br />
       var tmp = '&lt;h4&gt;hello&lt;/h4&gt;'<br />
             + '&lt;p&gt;这是直接调用$templateCache服务获取模板文件的方式&lt;/p&gt;'<br />
             + '&lt;a href="http://www.baidu.com"&gt;服务启用templateCache方式&lt;/a&gt;';<br />
       $templateCache.put('hello.html',tmp);<br />
   }])</pre>
</div>
<p>$templateCache的put()方法负责向内存中写入模板内容，然后在directive中用controllerUrl:'hello.html'就可以使用，甚至可以使用ng-include="'hello.heml'"来调用。&nbsp;<br /><strong>ng-include的方式：</strong></p>
<div>
<pre class="prettyprint linenums">&lt;div ng-app="myApp" ng-controller="myCtrl as ctrl"&gt;<br />
    &lt;div ng-include="'hello.html'"&gt;&lt;/div&gt;<br />
&lt;/div&gt;</pre>
</div>
<p>directive的方式：</p>
<div>
<pre class="prettyprint linenums">angular.module('myApp', [])<br />
    .directive('templateDemo', ['$log', function($log){<br />
        return {<br />
            restrict: 'A',<br />
            templateUrl: 'hello.html',<br />
            replace: true,<br />
            link: function($scope, iElm, iAttrs, controller) {}<br />
            }<br />
    }])

//html<br />
&lt;div ng-app="myApp" ng-controller="myCtrl as ctrl"&gt;<br />
    &lt;div template-demo&gt;&lt;/div&gt;<br />
&lt;/div&gt;</pre>
</div>
<p>$templateCache基于cacheFactory，接口保持一致，方法主要有：</p>
<table>
<thead>
<tr>
<th>方法</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>put</td>
<td>向内存写入模板内容</td>
</tr>
<tr>
<td>get</td>
<td>从内存获取模板内容</td>
</tr>
<tr>
<td>remove</td>
<td>传入key值，删除对应模板内容</td>
</tr>
<tr>
<td>removeAll</td>
<td>删除所有模板内容</td>
</tr>
<tr>
<td>destroy</td>
<td>解除key-value对应关系，但不释放内存</td>
</tr>
<tr>
<td>info</td>
<td>模板缓存对象的信息</td>
</tr>
</tbody>
</table>
<p><strong>方法三：$templateCache和ng-bind-html</strong></p>
<div>
<pre class="prettyprint linenums">&lt;div ng-app="Demo" ng-controller="testCtrl as ctrl"&gt;<br />
    &lt;div ng-bind-html="ctrl.text"&gt;&lt;/div&gt;<br />
&lt;/div&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">angular.module("Demo", [])<br />
    .run(["$templateCache",templateCache])<br />
    .controller("testCtrl", ["$templateCache","$sce",testCtrl]);<br />
    function templateCache($templateCache){<br />
      $templateCache.put('templateId.html', '&lt;a&gt;This is the content of the template&lt;/a&gt;');<br />
    }<br />
    function testCtrl($templateCache,$sce) {<br />
        var tpl = $templateCache.get('templateId.html');<br />
        tpl = $sce.trustAsHtml(tpl);<br />
        this.text = tpl;<br />
    };<br />
  }</pre>
</div>
<p>注意：使用ng-bind-html就要使用\$sce转成受信任的html插入代码。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7n6k9e.html">VMware下对虚拟机Ubuntu14系统所在分区sda1进行磁盘扩容</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2g787.html">FlashBuilder项目环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kj1m59.html">extern用法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxd52z9.html">&num;&num; Android 6&period;0 权限申请 &num;&num;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdn068.html">Java 对象 及 对象的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlvggk9.html">（转）SQL Server 性能调优（cpu）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnldp39.html">Spring源码阅读：IOC容器的设计与实现（二）&mdash;&mdash;ApplicationContext</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq45zn59.html">hdu 1541 Stars</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4oz5j8.html">有关RAVE报表 - 大富翁论坛20050419</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yzrgjq.html">Checking the content of the pointer</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r4019.html">Android之操作SQLite</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedgr09.html">hadoop2&period;5&period;2学习及实践笔记（二）&mdash;&mdash; 编译源代码及导入源码至eclipse</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv73woq.html">phpize php扩展模块安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj41x49.html">用C&plus;&plus;类模板实现栈结构出现的问题以及思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdd1dz9.html">hdu  Rescue  &lpar;bfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4z3j9.html">MariaDB第四章：视图，事务，索引，外键--小白博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/960037n9.html">hbase删除table时，显示table不存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllog0q.html">linux根目录介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy2o7xq.html">caffe boost cuda &lowbar;&lowbar;float128 undefined</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onw7x8.html">Just Oj 2017C语言程序设计竞赛高级组D&colon; 字符串最大表示（next数组）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1425k9.html">C&sol;C&plus;&plus;&mdash;&mdash;指针，引用做函数形参</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl2p239.html">Loading dl-debug&period;c in gdb &sol; Ubuntu 14&period;04&period;4 LTS</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm37zw9.html">rocketmq搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnxr2dq.html">鼠标不能用怎么办 USB OPTICAL MOUSE</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm3omw9.html">Centos7在线安装MySQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj00ko8.html">centos7 安装拼音输入法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2vv408.html">iOS 数据安全、数据加密传输</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7erk7g9.html">【js】 Uncaught RangeError&colon; Invalid string length</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnxv0mq.html">用Vue的父子组件通信实现todolist的功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql14gdk9.html">个人对js闭包的心得见解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
